<?php
  include_once("check.php");
  $data = "";     //HTML data
  $filename = ""; //File name
  $scode = "html";
  $message = "";  //Message
  
  //Write file
  if(isset($_POST["type"]) && "regist" == $_POST["type"])
  {
  
    $filename = $_POST["f"];
    if("" == $filename)
    {
      $message = "※ファイル名を記入してください";
      $data = $_POST["data"];
    }else if(preg_match("/[^A-Za-z\d\-\.]/", $filename)){
      $message = "※ファイル名はアルファベット・数字・ハイフンのみ有効です。";
      $data = $_POST["data"];
    }else if(file_exists("res/".$filename) && !isset($_POST["reregist"])){
      $message = "※ファイルは存在します。上書きする場合は「上書」をクリックしてください。";
      $data = $_POST["data"];
    }else{
      $file = fopen( "res/".$filename, "w" );
      if( $file == false )
      {
        exit();
      }
      fwrite( $file, $_POST["data"] );
      fclose( $file );
      header("Location: ./editres.php?f=".$filename);
    }
  }

  //Resolv file name
  if("" == $filename && isset($_GET["f"]))
  {
    $filename = $_GET["f"];
  }

  if(".css" == substr($filename, -4)) $scode = "css";
  if(".js" == substr($filename, -3)) $scode = "js";
  if(".php" == substr($filename, -4)) $scode = "php";
  if(".py" == substr($filename, -3)) $scode = "python";
  if(".java" == substr($filename, -5)) $scode = "java";
  if(".pl" == substr($filename, -3)) $scode = "perl";
  if(".rb" == substr($filename, -3)) $scode = "ruby";
  if(".vb" == substr($filename, -3)) $scode = "vb";
  if(".xml" == substr($filename, -4)) $scode = "xml";
  if(".c" == substr($filename, -2)) $scode = "c";
  if(".cpp" == substr($filename, -4)) $scode = "cpp";
  if(".sql" == substr($filename, -4)) $scode = "sql";
  if(".tsql" == substr($filename, -5)) $scode = "tsql";
  if(".basic" == substr($filename, -6)) $scode = "basic";
  if(".pas" == substr($filename, -4)) $scode = "pas";
  if(".cfm" == substr($filename, -4)) $scode = "coldfusion";
  if(".txt" == substr($filename, -4)) $scode = "robotstxt";

  //Read data
  if("" <> $filename && "" == $data && file_exists("res/".$filename))
  {
    $file = fopen("res/".$filename, 'r');
    $filesize = filesize( "res/".$filename );
    if($filesize > 0)
    {
      $data = fread( $file, $filesize );
    }
    fclose($file);
  }
  
  //Read header data
  $hfile = fopen("file/head", 'r');
  $hfilesize = filesize( "file/head" );
  if($hfilesize > 0)
  {
    $hdata = fread( $hfile, $hfilesize );
  }
  fclose($hfile);
  $hdata = str_replace("#edit#", $filename, $hdata);

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Language" content="ja">
<title>リソース編集</title>
<script src="ckeditor/ckeditor.js"></script>
<link rel="stylesheet" type="text/css" href="res/main.css" />
<link rel="stylesheet" type="text/css" href="res/menu.css" />
<script src="jquery-1.9.1.min.js"></script>
<script language="Javascript" type="text/javascript" src="./edit_area/edit_area_loader.js"></script>
<script src="res/main.js"></script>
<style type="text/css">
<!--
body{
background-color:#EBE9D3;
}
ul.dropdown li {
background-color:#EBE9D3;
}
a{
color:#666666;
font-weight:bold;
}
-->
</style>
</head>
<body>
<?=$hdata ?>
<form name="write" method="post">
<hr />
<input id="f" type="text" name="f" value="<?= $filename ?>" /><input type="submit" value="  新規  " /><input type="button" onclick="$('input[name=regist]').attr('name','reregist');$('#frame_data').contents().find('#a_save').click();" value="  上書  " />
<?php if("" <> $filename) { ?>
<a href="./res/<?=$filename ?>" target="_blank">プレビュー</a>　
<?php } ?>
利用可能な拡張子：[.css .js .php .py .java .pl .rb .vb .xml .c .cpp .sql .tsql .basic .pas .cfm .txt]<br />
<div class="message"><?=$message ?></div>
<hr />
<textarea id="data" name="data" style="width:100%"><?= $data ?></textarea>
※css/jsは保存後キャッシュクリアで反映されます。
<input type="hidden" name="type" value="regist" />
<input type="hidden" name="regist" value="on" />
</form>
<script type="text/javascript">
<!--
var need_createRange = !("selectionStart" in document.createElement("textarea"));
editAreaLoader.init({
	id: "data"	// id of the textarea to transform	
	,name: "data"
	,start_highlight: true
	,allow_toggle: false
	,language: "ja"
	,syntax: "<?= $scode ?>"
	,toolbar: "save, |, search, go_to_line, |, undo, redo, |, select_font, |, syntax_selection, |, change_smooth_selection, highlight, reset_highlight, word_wrap, |, help"
	,syntax_selection_allow: "css,html,js,php,python,java,perl,ruby,vb,xml,c,cpp,sql,tsql,basic,pas,coldfusion,robotstxt,brainfuck"
	,show_line_colors: true
	,save_callback: "file_save"
	,replace_tab_by_spaces: 4
});

$("form").submit(function() {
	if("" == document.getElementById("f").value){
		alert("名前を記入してください。");
		return false;
	}else if (document.getElementById("f").value.match(/[^A-Za-z\d\-\.]/)) {
		alert("名前はアルファベット・数字・ハイフンのみ有効です。");
		return false;
	}else if (document.getElementById("f").value.match(/^[^.]+$/)) {
		alert("拡張子を指定してください。");
		return false;
	}
	return true;
});

function file_save(id, content){
	if("" == document.getElementById("f").value){
		alert("名前を記入してください。");
		return;
	}else if (document.getElementById("f").value.match(/[^A-Za-z\d\-\.]/)) {
		alert("名前はアルファベット・数字・ハイフンのみ有効です。");
		return;
	}else if (document.getElementById("f").value.match(/^[^.]+$/)) {
		alert("拡張子を指定してください。");
		return;
	}
	$("textarea#data").html(content);
	document.write.submit();
}

$(document).ready(function(){
	$("#data").height(($(document).height() - 150) + "px");
});

// -->
</script>
</body>
</html>