<?php
if(isset($_POST["agree"])){
  $file = fopen( "file/agreed", "w" );
  fwrite( $file, "I have agreed with the agreement of this application." );
  fclose( $file );
}
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body>
<?php
$isIndex = true;
echo "<h1>「ダンボールボックスCMS」 SETUP</h1>";
echo "<b>■動作チェック</b><br />";

//■file書き込み権限チェック
if(is_writable("file/"))
{
	echo "○fileディレクトリ書き込みチェック:<font color='blue'><b>OK!!</b></font><br />";
}else{
	echo "<font color='red'><b>Check!!</b></font>:/fileディレクトリが存在しないか、書き込みができません。権限を与えてください。<br />";
	$isIndex = false;
}

//■top書き込み権限チェック
if(is_writable("file/top"))
{
	echo "○topファイル書き込みチェック:<font color='blue'><b>OK!!</b></font><br />";
}else{
	echo "<font color='red'><b>Check!!</b></font>:/file/topファイルが存在しないか、書き込みができません。ファイルを確認して権限を与えてください。<br />";
	$isIndex = false;
}

//■head書き込み権限チェック
if(is_writable("file/head"))
{
	echo "○headファイル書き込みチェック:<font color='blue'><b>OK!!</b></font><br />";
}else{
	echo "<font color='red'><b>Check!!</b></font>:/file/headファイルが存在しないか、書き込みができません。ファイルを確認して権限を与えてください。<br />";
	$isIndex = false;
}

//■アクセス元チェック
$isValid = false;
$addr = $_SERVER["REMOTE_ADDR"];
//PrivateAddress (RFC 1597)

if(preg_match('/^::1$/',$addr))
{
  $isValid = true;
}
elseif(preg_match('/^192\.168\.[0-9]{1,3}\.[0-9]{1,3}$/',$addr))
{
  $isValid = true;
}
elseif(preg_match('/^172\.(1[6-9]|2[0-9]|3[0-1])\.[0-9]{1,3}\.[0-9]{1,3}$/',$addr))
{
  $isValid = true;
}

if($isValid){
	echo "○アクセス元チェック:<font color='blue'><b>OK!!</b></font><br />";
}else{
	echo "<font color='orange'><b>Check!!</b></font>:プライベートアドレス(localhost,192.168.*, 172.16-31.*)以外のIPはセキュリティー上利用できません。<br />";
	$isIndex = false;
}

//■同意チェック
if($isIndex){
	if(file_exists("file/agreed"))
	{
		echo "○同意しました。:<font color='blue'><b>OK!!</b></font><br />";
	}else{
		echo "<br />■<b>このアプリケーションをご利用する上での注意と規約<br />（※必ず以下の文書を了承の上、同意するボタンを押してください）</b><br />";
		echo "このアプリケーション自体、セキュリティーを考慮した作りになっておりません。<br />";
		echo "その為、アプリケーションの管理者本人とその関係者以外（不特定多数の第三者）の利用は禁止いたします。<br />";
		echo "また、このアプリケーションを利用する上で発生したトラブル・障害は一切、製作者(RAWSEQ)の責となりません。<br />";
		echo "<form method='post'><input type='submit' name='agree' value='上記規約を了承の上、同意する' /></form>";
		$isIndex = false;
	}
}
if($isIndex){
	echo "<br />◎ご利用準備が整いました！以下のリンクから利用開始してください。<br />";
	echo "<a href='./'>[ START ]</a>";
}

?>
</body>
</html>