<?php

if(!file_exists("file/agreed"))
{
	header("Location:./setup.php");
	exit;
}

$isValid = false;
$addr = $_SERVER["REMOTE_ADDR"];

//PrivateAddress (RFC 1597)

if(preg_match('/^::1$/',$addr))
{
  $isValid = true;
}
elseif(preg_match('/^10\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/',$addr))
{
  $isValid = true;
}
elseif(preg_match('/^192\.168\.[0-9]{1,3}\.[0-9]{1,3}$/',$addr))
{
  $isValid = true;
}
elseif(preg_match('/^172\.(1[6-9]|2[0-9]|3[0-1])\.[0-9]{1,3}\.[0-9]{1,3}$/',$addr))
{
  $isValid = true;
}
elseif(preg_match('/^f[cd][0-9a-f]{2}(\:[0-9a-f]{0,4}){1,6}\:([0-9a-f]{2,4}|[1-9a-f])$/i',$addr))
{
	$isValid = true;
}
elseif(preg_match('/^fe[89ab][0-9a-f](\:[0-9a-f]{0,4}){1,6}\:([0-9a-f]{2,4}|[1-9a-f])$/i',$addr))
{
	$isValid = true;
}

if(!$isValid)
{
	header("HTTP/1.0 404 Not Found");
	exit;
}
?>