$(document).ready(function () {
    var syntax_id = 0;
    $("textarea.syntax").each(function() {
        $(this).attr("id","syntax_"+syntax_id);
        var scode = "html";
        
        if($(this).hasClass("php")) scode = "php";
        if($(this).hasClass("css")) scode = "css";
        if($(this).hasClass("js")) scode = "js";
        if($(this).hasClass("python")) scode = "python";
        if($(this).hasClass("vb")) scode = "vb";
        if($(this).hasClass("xml")) scode = "xml";
        if($(this).hasClass("c")) scode = "c";
        if($(this).hasClass("cpp")) scode = "cpp";
        if($(this).hasClass("sql")) scode = "sql";
        if($(this).hasClass("basic")) scode = "basic";
        if($(this).hasClass("pas")) scode = "pas";
        if($(this).hasClass("brainfuck")) scode = "brainfuck";
        if($(this).hasClass("coldfusion")) scode = "coldfusion";
        if($(this).hasClass("java")) scode = "java";
        if($(this).hasClass("perl")) scode = "perl";
        if($(this).hasClass("robotstxt")) scode = "robotstxt";
        if($(this).hasClass("ruby")) scode = "ruby";
        if($(this).hasClass("tsql")) scode = "tsql";
        
        editAreaLoader.init({
            id: "syntax_"+syntax_id // id of the textarea to transform  
            ,start_highlight: true
            ,allow_toggle: false
            ,language: "ja"
            ,syntax: scode  
            ,toolbar: "search, go_to_line, |, undo, redo, |, select_font, |, syntax_selection, |, change_smooth_selection, highlight, reset_highlight, word_wrap, |, help"
            ,syntax_selection_allow: "css,html,js,php,python,vb,xml,c,cpp,sql,basic,pas,brainfuck"
            ,show_line_colors: true
        });
        syntax_id++;
    });
    
});